<?php
// Debugging
error_reporting(E_ALL);
ini_set("display_errors", 1);

// Session init
session_start();
header("Cache-control: private");

// Includes & config
require("classes.inc.php");
$c = $config = new Config();
date_default_timezone_set($config->timezone);
require("db-connect.inc.php");

// Session variable & parameter management
if ((isset($_POST["minyear"])) && (isset($_POST["maxyear"]))) {
	$_SESSION["minyear"] = $_POST["minyear"];
	$_SESSION["maxyear"] = $_POST["maxyear"];
} else {
	$result = $cnx->query("select min(yea) as mini, max(yea) as maxi from btw_paper");
	$row = $result->fetch(PDO::FETCH_ASSOC);
	if (!isset($_SESSION["minyear"])) if ($row["mini"]) $_SESSION["minyear"] = $row["mini"]; else $_SESSION["minyear"] = 0;
	if (!isset($_SESSION["maxyear"])) if ($row["maxi"]) $_SESSION["maxyear"] = $row["maxi"]; else $_SESSION["maxyear"] = 0;
}
if (isset($_POST["keyword"])) $_SESSION["keyword"] = $_POST["keyword"]; else if (!isset($_SESSION["keyword"])) $_SESSION["keyword"] = "";
if (isset($_POST["cutnpaste"])) $_SESSION["cutnpaste"] = $_POST["cutnpaste"]; else $_SESSION["cutnpaste"] = "off";

?>
<!DOCTYPE html>
<html>
<head>
	<!-- <meta charset="windows-1252" /> -->
    <meta charset="utf-8" /> 
	<title>BibTeXWeb: Publications of <?php echo $config->username ?></title>
	<link rel="stylesheet" href="<?php echo $config->cssname ?>" type="text/css" />
	<meta name="Author" content="Jérôme Darmont" />
	<meta name="Keywords" content="BibTeXWeb,BibTeX,LaTeX,publication,reference,article,book,inbook,inproceedings,misc,techreport,phdthesis,mastersthesis" />
	<meta name="Description" content="BibTeXWeb is a PHP on-line publication list manager with BibTeX support." />
</head>
<body>
<main>
<?php

// Title
echo "<div class=\"floatright\"><a href=\"$config->homepage\" class=\"back allwhite\">Back</a>\n";
echo "<a href=\"files/btw-rss.xml\"><img src=\"img/logo-rss.png\" alt=\"RSS stream\" class=\"icon-right\" /></a></div>\n";
echo "<h2>Publications of $config->username</h2>\n\n";

// Display management
$d = new Display($config);
if (isset($_GET["action"])) $action = $_GET["action"];
else $action = "";
switch ($action) {
	case "bibtex":		$d->bibtex($_GET["refr"], $_GET["bibkey"]); break;
	case "xml":			$d->xml($config->username, $_GET["refr"], $_GET["bibkey"]); break;
	case "abstract":	$d->asbtract($_GET["refr"], $_GET["bibkey"]); break;
	case "fullpaper":	$d->fullpaper($_GET["refr"], $_GET["bibkey"]); break; 
	case "bibtexall":	$d->bibtexall($config->username); break;
	case "xmlall":		$d->xml($config->username); break;
	case "stats":		$d->stats(); break;
	case "index":		$d->author_index(); break;
	default: 			$d->list_all($config->homepage, $config->username);
}

// Footer
require("copyright.inc.php");

?>
</main>
</body>
</html>