<?php

// Session init
session_start();
header("Cache-control: private");

// Includes
require("classes.inc.php");

// Session variable & parameter management
if (!isset($_SESSION["login"])) {
	$_SESSION["login"] = "";
	$_SESSION["passwd"] = "";
	$clogin = "";
	$cpasswd = "";
} else {
	if (isset($_POST["clogin"])) {	
		$_SESSION["login"] = $_POST["clogin"];
		$_SESSION["passwd"] = $_POST["cpasswd"];
		$clogin = $_POST["clogin"];
		$cpasswd = $_POST["cpasswd"];
	} else {
		$clogin = $_SESSION["login"];
		$cpasswd = $_SESSION["passwd"];
	}
}
?>
<!DOCTYPE html>
<html>
<head>
	<meta charset="windows-1252" /> 
	<title>BibTeXWeb Installation</title>
	<link rel="stylesheet" href="default.css" type="text/css" />
	<meta name="Author" content="Jérôme Darmont" />
	<meta name="Keywords" content="BibTeXWeb,BibTeX,publication" />
	<meta name="Description" content="BibTeXWeb is a PHP on-line publication list manager with BibTeX support." />
</head>
<body>
<main>

<h1>BibTeXWeb Installation</h1>

<?php

// Display management
$d = new Display("");

// Configuration file existence test

if (file_exists("config.inc.php")) { 

	// Password check
	$c = new Config();
	if (($clogin == $c->login) && ($cpasswd == $c->passwd)) {
		if (isset($_POST["action"])) $action = $_POST["action"];
		else $action = "";
		switch ($action) {
			// Create config file
			case "create_config":
				$c = new Config($_POST["username"], $_POST["homepage"], $_POST["hostname"], $_POST["login"], $_POST["passwd"], $_POST["dbname"], $_POST["cssname"], $_POST["rsslength"], $_POST["emailalert"], $_POST["timezone"]);
				$c->save(0);				
			break;
			// Modify config file
			case "modify_config":
				$d->install_phase1("update");
			break;
			// Create database
			case "create_db":
				$db = new Database($c);
				$db->create($c);
			break;
			// Confirm DB destruction
			case "destroy_db_confirm":
				$d->dbdestroy_form();
			break;
			// Destroy DB
			case "destroy_db":
				$db = new Database($c);
				$db->destroy();			
			break;
			// Log out
			case "logout":
				$d->logout(); 
			break;
			// Menu
			default: 				
				$d->install_phase2();
		}
	} else { // Incorrect login or password
		if ($clogin) echo "<p>Incorrect login or password. <a href=\"" . $_SERVER["PHP_SELF"] . "\">Try again</a>!</p>\n\n";
		$d->identification();
	}
	
} else { // Configuration file does not exist => must be created

	if (!isset($_POST["username"])) $d->install_phase1(); // Config form
	else { // Create config file
		$c = new Config($_POST["username"], $_POST["homepage"], $_POST["hostname"], $_POST["login"], $_POST["passwd"], $_POST["dbname"], $_POST["cssname"], $_POST["rsslength"], $_POST["emailalert"], $_POST["timezone"]);
		$c->save();
	}
	
}

// Footer
require("copyright.inc.php");

?>
</main>
</body>
</html>