<?php

// Session init
session_start();
header("Cache-control: private");

// Includes
require("classes.inc.php");
$c = $config = new Config();
date_default_timezone_set($config->timezone);
require("db-connect.inc.php");

// Session variable & parameter management
if (!isset($_SESSION["login"])) {
	$_SESSION["login"] = "";
	$_SESSION["passwd"] = "";
	$clogin = "";
	$cpasswd = "";
} else {
	if (isset($_POST["clogin"])) {	
		$_SESSION["login"] = $_POST["clogin"];
		$_SESSION["passwd"] = $_POST["cpasswd"];
		$clogin = $_POST["clogin"];
		$cpasswd = $_POST["cpasswd"];
	} else {
		$clogin = $_SESSION["login"];
		$cpasswd = $_SESSION["passwd"];
	}
}
?>
<!DOCTYPE html>
<html>
<head>
	<meta charset="windows-1252" /> 
	<title>BibTeXWeb Management</title>
	<link rel="stylesheet" href="<?php echo $c->cssname ?>" type="text/css" />
	<meta name="Author" content="Jrme Darmont" />
	<meta name="Keywords" content="BibTeXWeb,BibTeX,publication" />
	<meta name="Description" content="BibTeXWeb is a PHP on-line publication list manager with BibTeX support." />
</head>
<body>
<main>

<h1>BibTeXWeb Management</h1>

<?php

// Display management
$d = new Display($config);

// Password check
if (($clogin == $c->login) && ($cpasswd == $c->passwd)) {
	if (isset($_POST["action"])) $action = $_POST["action"];
	else $action = "";
	switch ($action) {
		// Log out
		case "logout":
			$d->logout(); 
		break;
		// Add author/series/institution form
		case "form_add_asi":
			$t = new Table($config, $_POST["table"]);
			$asi = $d->new_asi($_POST["table"], $t->get_new_id());
			$asi->form("add_asi");
		break;
		// Add author/series/institution
		case "add_asi":
			if (isset($_POST["address"])) $address = $_POST["address"]; else $address = "";
			if (isset($_POST["url"])) $url = $_POST["url"]; else $url = "";
			$asi = $d->new_asi($_POST["table"], $_POST["id"]);
			$d->msg($asi->save($_POST["name"], $url, $address));
		break;
		// Modify author/series/institution form
		case "form_modify_asi": 
			$t = new Table($config, $_POST["table"]);
			$asi = $d->new_asi($_POST["table"], $t->get_id($_POST["name"]));
			$asi->load();
			$asi->form("modify_asi");
		break;
		// Modify author/series/institution 
		case "modify_asi": 
			if (isset($_POST["address"])) $address = $_POST["address"]; else $address = "";
			if (isset($_POST["url"])) $url = $_POST["url"]; else $url = "";		
			$asi = $d->new_asi($_POST["table"], $_POST["id"]);
			$d->msg($asi->update($_POST["name"], $url, $address));			
		break;		
		// Delete author/series/institution form
		case "form_delete_asi":
			$t = new Table($config, $_POST["table"]);
			$asi = $d->new_asi($_POST["table"], $t->get_id($_POST["name"]));
			$asi->load();
			if ($asi->form_delete()) $d->return_button();
		break;
		// Delete author/series/institution
		case "delete_asi":
			$asi = $d->new_asi($_POST["table"], $_POST["id"]);
			$d->msg($asi->delete());
		break;	
		// Select reference key and type		
		case "add_ref_key":
			$d->add_ref_key();
		break;
		// Check reference key
		case "add_ref_check_key": 
			$d->add_ref_check_key($_POST["bibkey"], $_POST["reference"]);
		break;
		// Add/remove authors
		case "add_ref_authors": 
			$d->select_authed("add_ref_authors", "authors", $_POST["onvalid"], $_POST["bibkey"], $_POST["reference"], $_POST["subaction"], $_POST["name"]);
		break;
		// Add/remove editors
		case "add_ref_editors": 
			if (isset($_POST["name"])) $name = $_POST["name"]; else $name = "";
			$d->select_authed("add_ref_editors", $_POST["table"], "add_ref_form", $_POST["bibkey"], $_POST["reference"], $_POST["subaction"], $name);
		break;	
		// Add reference form
		case "add_ref_form": 
			$publi = $d->new_publi($_POST["reference"], $_POST["bibkey"]);
			$publi->form("add");			
		break;		
		// Add reference
		case "add_ref":
			$publi = $d->new_publi($_POST["reference"], $_POST["bibkey"]);
			if (isset($_POST["title"])) $title = $_POST["title"]; else $title = "";
			if (isset($_POST["year"])) $year = $_POST["year"]; else $year = "";
			if (isset($_POST["month"])) $month = $_POST["month"]; else $month = "";
			if (isset($_POST["note"])) $note = $_POST["note"]; else $note = "";
			if (isset($_POST["scope"])) $scope = $_POST["scope"]; else $scope = "";
			if (isset($_POST["abstract"])) $abstract = $_POST["abstract"]; else $abstract = "";
			if (isset($_POST["keywords"])) $keywords = $_POST["keywords"]; else $keywords = "";
			if (isset($_FILES["file"]["tmp_name"])) $tmpfile = $_FILES["file"]["tmp_name"]; else $tmpfile = "";
			if (isset($_FILES["file"]["name"])) $filename = $_FILES["file"]["name"]; else $filename = "";
			if (isset($_POST["old_file"])) $oldfile = $_POST["old_file"]; else $oldfile = "";
			if (isset($_POST["paperurl"])) $paperurl = $_POST["paperurl"]; else $paperurl = "";
			if (isset($_POST["journalname"])) $journalname = $_POST["journalname"]; else $journalname = "";
			if (isset($_POST["volume"])) $volume = $_POST["volume"]; else $volume = "";
			if (isset($_POST["number"])) $number = $_POST["number"]; else $number = "";
			if (isset($_POST["pages"])) $pages = $_POST["pages"]; else $pages = "";
			if (isset($_POST["seriesname"])) $seriesname = $_POST["seriesname"]; else $seriesname = "";
			if (isset($_POST["publishername"])) $publishername = $_POST["publishername"]; else $publishername = "";
			if (isset($_POST["edition"])) $edition = $_POST["edition"]; else $edition = "";
			if (isset($_POST["organizationname"])) $organizationname = $_POST["organizationname"]; else $organizationname = "";
			if (isset($_POST["booktitle"])) $booktitle = $_POST["booktitle"]; else $booktitle = "";
			if (isset($_POST["url"])) $url = $_POST["url"]; else $url = "";
			if (isset($_POST["howpublished"])) $howpublished = $_POST["howpublished"]; else $howpublished = "";
			if (isset($_POST["schoolname"])) $schoolname = $_POST["schoolname"]; else $schoolname = "";
			if (isset($_POST["institutionname"])) $institutionname = $_POST["institutionname"]; else $institutionname = "";
			if (isset($_POST["type"])) $type = $_POST["type"]; else $type = "";
			$result = $publi->save($title, $year, $month, $note, $scope, $abstract, $keywords, $tmpfile, $filename, $oldfile, $paperurl, $journalname, $volume, $number, $pages, $seriesname, $publishername, $edition, $organizationname, $booktitle, $url, $howpublished, $schoolname, $institutionname, $type);
			$d->msg($result);
			if ($result) {
				$publi->load();
				$publi->announce($c);
			}
		break;
		// Modify reference form
		case "form_modify_ref": 
			$result = $cnx->query("select reference from btw_paper where bibkey='" . $_POST["bibkey"] . "'");
			$row = $result->fetch(PDO::FETCH_ASSOC);
			$publi = $d->new_publi($row["reference"], $_POST["bibkey"]);
			$publi->load();
			if (isset($_POST["subaction"])) $subaction = $_POST["subaction"]; else $subaction = "";
			if (isset($_POST["name"])) $name = $_POST["name"]; else $name = "";
			$publi->form_update($d, $subaction, $name);	
		break;	
		// Modify reference key and/or type
		case "modify_key_type": 
			$publi = $d->new_publi($_POST["reference"], $_POST["oldkey"]);
			$d->msg($publi->update_key($_POST["bibkey"]));
		break;
		// Modify reference
		case "modify_ref":
			$publi = $d->new_publi($_POST["reference"], $_POST["bibkey"]);
			if (isset($_POST["title"])) $title = $_POST["title"]; else $title = "";
			if (isset($_POST["year"])) $year = $_POST["year"]; else $year = "";
			if (isset($_POST["month"])) $month = $_POST["month"]; else $month = "";
			if (isset($_POST["note"])) $note = $_POST["note"]; else $note = "";
			if (isset($_POST["scope"])) $scope = $_POST["scope"]; else $scope = "";
			if (isset($_POST["abstract"])) $abstract = $_POST["abstract"]; else $abstract = "";
			if (isset($_POST["keywords"])) $keywords = $_POST["keywords"]; else $keywords = "";
			if (isset($_FILES["file"]["tmp_name"])) $tmpfile = $_FILES["file"]["tmp_name"]; else $tmpfile = "";
			if (isset($_FILES["file"]["name"])) $filename = $_FILES["file"]["name"]; else $filename = "";
			if (isset($_POST["old_file"])) $oldfile = $_POST["old_file"]; else $oldfile = "";
			if (isset($_POST["paperurl"])) $paperurl = $_POST["paperurl"]; else $paperurl = "";
			if (isset($_POST["journalname"])) $journalname = $_POST["journalname"]; else $journalname = "";
			if (isset($_POST["volume"])) $volume = $_POST["volume"]; else $volume = "";
			if (isset($_POST["number"])) $number = $_POST["number"]; else $number = "";
			if (isset($_POST["pages"])) $pages = $_POST["pages"]; else $pages = "";
			if (isset($_POST["seriesname"])) $seriesname = $_POST["seriesname"]; else $seriesname = "";
			if (isset($_POST["publishername"])) $publishername = $_POST["publishername"]; else $publishername = "";
			if (isset($_POST["edition"])) $edition = $_POST["edition"]; else $edition = "";
			if (isset($_POST["organizationname"])) $organizationname = $_POST["organizationname"]; else $organizationname = "";
			if (isset($_POST["booktitle"])) $booktitle = $_POST["booktitle"]; else $booktitle = "";
			if (isset($_POST["url"])) $url = $_POST["url"]; else $url = "";
			if (isset($_POST["howpublished"])) $howpublished = $_POST["howpublished"]; else $howpublished = "";
			if (isset($_POST["schoolname"])) $schoolname = $_POST["schoolname"]; else $schoolname = "";
			if (isset($_POST["institutionname"])) $institutionname = $_POST["institutionname"]; else $institutionname = "";
			if (isset($_POST["type"])) $type = $_POST["type"]; else $type = "";
			$d->msg($publi->update($title, $year, $month, $note, $scope, $abstract, $keywords, $tmpfile, $filename, $oldfile, $paperurl, $journalname, $volume, $number, $pages, $seriesname, $publishername, $edition, $organizationname, $booktitle, $url, $howpublished, $schoolname, $institutionname, $type));
		break;	
		// Delete reference form	
		case "form_delete_ref": 	
			$result = $cnx->query("select reference from btw_paper where bibkey='" . $_POST["bibkey"] . "'");
			$row = $result->fetch(PDO::FETCH_ASSOC);
			$publi = $d->new_publi($row["reference"], $_POST["bibkey"]);		
			$publi->load();
			$publi->form_delete();
		break;
		// Delete reference
		case "delete_ref": 
			$publi = $d->new_publi($_POST["reference"], $_POST["bibkey"]);
			$publi->load();
			$d->msg($publi->delete($_POST["bibkey"]));
		break;		
		// BibTeX import phase 1: Load entries
		case "import_load": 
			if (isset($_POST["id"])) $id = $_POST["id"]; else $id = "";
			if (isset($_FILES["file"]["tmp_name"])) $tmpfile = $_FILES["file"]["tmp_name"]; else $tmpfile = "";
			if (isset($_FILES["file"]["name"])) $filename = $_FILES["file"]["name"]; else $filename = "";			
			$d->bibtex_import_phase1($id, $tmpfile, $filename);
		break;
		// BibTeX import phase 2: Requisite storage
		case "import_requisites": 
			if (isset($_POST["id"])) $id = $_POST["id"]; else $id = "";
			if (isset($_POST["req"])) $req = $_POST["req"]; else $req = "";
			if (isset($_POST["reference"])) $reference = $_POST["reference"]; else $reference = "";
			if (isset($_POST["scope"])) $scope = $_POST["scope"]; else $scope = "";
			if (isset($_POST["bibkey"])) $bibkey = $_POST["bibkey"]; else $bibkey = "";
			if (isset($_POST["author"])) $author = $_POST["author"]; else $author = "";
			if (isset($_POST["editor"])) $editor = $_POST["editor"]; else $editor = "";
			if (isset($_POST["title"])) $title = $_POST["title"]; else $title = "";
			if (isset($_POST["year"])) $year = $_POST["year"]; else $year = "";
			if (isset($_POST["month"])) $month = $_POST["month"]; else $month = "";
			if (isset($_POST["note"])) $note = $_POST["note"]; else $note = "";
			if (isset($_POST["journal"])) $journal = $_POST["journal"]; else $journal = "";
			if (isset($_POST["volume"])) $volume = $_POST["volume"]; else $volume = "";
			if (isset($_POST["number"])) $number = $_POST["number"]; else $number = "";
			if (isset($_POST["pages"])) $pages = $_POST["pages"]; else $pages = "";
			if (isset($_POST["series"])) $series = $_POST["series"]; else $series = "";
			if (isset($_POST["publisher"])) $publisher = $_POST["publisher"]; else $publisher = "";
			if (isset($_POST["edition"])) $edition = $_POST["edition"]; else $edition = "";
			if (isset($_POST["booktitle"])) $booktitle = $_POST["booktitle"]; else $booktitle = "";
			if (isset($_POST["organization"])) $organization = $_POST["organization"]; else $organization = "";
			if (isset($_POST["school"])) $school = $_POST["school"]; else $school = "";
			if (isset($_POST["howpublished"])) $howpublished = $_POST["howpublished"]; else $howpublished = "";
			if (isset($_POST["institution"])) $institution = $_POST["institution"]; else $institution = "";
			if (isset($_POST["type"])) $type = $_POST["type"]; else $type = "";
			if (isset($_POST["address"])) $address = $_POST["address"]; else $address = "";
			if (isset($_POST["auth_id_list"])) $auth_id_list = $_POST["auth_id_list"]; else $auth_id_list = "";
			if (isset($_POST["index_a"])) $index_a = $_POST["index_a"]; else $index_a = "";
			if (isset($_POST["ed_id_list"])) $ed_id_list = $_POST["ed_id_list"]; else $ed_id_list = "";
			if (isset($_POST["index_e"])) $index_e = $_POST["index_e"]; else $index_e = "";
			if (isset($_POST["idseries"])) $idseries = $_POST["idseries"]; else $idseries = "";
			if (isset($_POST["idinst"])) $idinst = $_POST["idinst"]; else $idinst = "";
			if (isset($_POST["abstract"])) $abstract = $_POST["abstract"]; else $abstract = "";
			if (isset($_POST["keywords"])) $keywords = $_POST["keywords"]; else $keywords = "";						
			if (isset($_POST["subaction"])) $subaction = $_POST["subaction"]; else $subaction = "";
			if (isset($_POST["variant_param"])) $variant_param = $_POST["variant_param"]; else $variant_param = "";
			if ($req == "INIT") $req = $d->import_requisites($author, $editor, $journal, $series, $publisher, $school, $institution, $organization);
			$d->bibtex_import_phase2($id, $req, $reference, $scope, $bibkey, $author, $editor, $title, $year, $month, $note, $journal, $volume, $number, $pages, $series, $publisher, $edition, $booktitle, $organization, $school, $howpublished, $institution, $type, $address, $auth_id_list, $index_a, $ed_id_list, $index_e, $idseries, $idinst, $abstract, $keywords, $subaction, $variant_param);
		break;
		// BibTeX import phase 3: Reference storage
		case "import_insert": 
			if (isset($_POST["id"])) $id = $_POST["id"]; else $id = "";
			if (isset($_POST["bibkey"])) $bibkey = $_POST["bibkey"]; else $bibkey = "";
			if (isset($_POST["reference"])) $reference = $_POST["reference"]; else $reference = "";
			if (isset($_POST["title"])) $title = $_POST["title"]; else $title = "";
			if (isset($_POST["year"])) $year = $_POST["year"]; else $year = "";
			if (isset($_POST["month"])) $month = $_POST["month"]; else $month = "";
			if (isset($_POST["note"])) $note = $_POST["note"]; else $note = "";	
			if (isset($_POST["scope"])) $scope = $_POST["scope"]; else $scope = "";
			if (isset($_POST["auth_id_list"])) $auth_id_list = $_POST["auth_id_list"]; else $auth_id_list = "";
			if (isset($_POST["index_a"])) $index_a = $_POST["index_a"]; else $index_a = "";
			if (isset($_POST["ed_id_list"])) $ed_id_list = $_POST["ed_id_list"]; else $ed_id_list = "";
			if (isset($_POST["index_e"])) $index_e = $_POST["index_e"]; else $index_e = "";
			if (isset($_POST["series"])) $series = $_POST["series"]; else $series = "";
			if (isset($_POST["idseries"])) $idseries = $_POST["idseries"]; else $idseries = "";
			if (isset($_POST["volume"])) $volume = $_POST["volume"]; else $volume = "";
			if (isset($_POST["number"])) $number = $_POST["number"]; else $number = "";
			if (isset($_POST["pages"])) $pages = $_POST["pages"]; else $pages = "";
			if (isset($_POST["institution"])) $institution = $_POST["institution"]; else $institution = "";
			if (isset($_POST["idinst"])) $idinst = $_POST["idinst"]; else $idinst = "";
			if (isset($_POST["edition"])) $edition = $_POST["edition"]; else $edition = "";
			if (isset($_POST["idinstp"])) $idinstp = $_POST["idinstp"]; else $idinstp = "";
			if (isset($_POST["publisher"])) $publisher = $_POST["publisher"]; else $publisher = "";			
			if (isset($_POST["booktitle"])) $booktitle = $_POST["booktitle"]; else $booktitle = "";
			if (isset($_POST["idinsto"])) $idinsto = $_POST["idinsto"]; else $idinsto = "";			
			if (isset($_POST["organization"])) $organization = $_POST["organization"]; else $organization = "";
			if (isset($_POST["howpublished"])) $howpublished = $_POST["howpublished"]; else $howpublished = "";
			if (isset($_POST["type"])) $type = $_POST["type"]; else $type = "";
			if (isset($_POST["school"])) $school = $_POST["school"]; else $school = "";
			if (isset($_POST["institution"])) $institution = $_POST["institution"]; else $institution = "";
			if (isset($_POST["abstract"])) $abstract = $_POST["abstract"]; else $abstract = "";
			if (isset($_POST["keywords"])) $keywords = $_POST["keywords"]; else $keywords = "";						
			$publi = $d->new_publi($_POST["reference"], $_POST["bibkey"]);
			if ($publi->import($title, $year, $month, $note, $scope, $auth_id_list, $ed_id_list, $idseries, $volume, $number, $pages, $idinst, $edition, $idinstp, $booktitle, $idinsto, $howpublished, $type, $index_a, $index_e, $series,$publisher, $organization, $school, $institution, $abstract, $keywords)) {
				echo "<p>BibTeX entry imported.</p>\n\n";
				$publi->load();
				$publi->announce($c);
			} else echo "<p><strong>Error:</strong> BibTeX entry has not been properly imported.</p>\n\n";  
			$d->next_step($id, "load");
		break;
		// Menu
		default: 		
			$d->mgt_menu();
	}
} else { // Incorrect login or password
	if ($clogin) echo "<p>Incorrect login or password. <a href=\"" . $_SERVER["PHP_SELF"] . "\">Try again</a>!</p>\n\n";
	$d->identification();
} 

// Footer
require("copyright.inc.php");

?>
</main>
</body>
</html>